//---------------------------------------------------------------------------
#ifndef GraphicUH
#define GraphicUH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <fgwin.h>
#include <vcl\Menus.hpp>

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:   // IDE-managed Components
	TMainMenu *MainMenu1;
	TMenuItem *Points1;
	TMenuItem *Lines1;
	TMenuItem *Rectangles1;
	TMenuItem *Circles1;
	TMenuItem *Ellipses1;
	TMenuItem *Polygons1;
	TMenuItem *Paint1;
	TMenuItem *Quit1;
   void __fastcall FormActivate(TObject *Sender);
   void __fastcall FormCreate(TObject *Sender);
   void __fastcall FormPaint(TObject *Sender);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall FormDestroy(TObject *Sender);
   void __fastcall Points1Click(TObject *Sender);
   void __fastcall Lines1Click(TObject *Sender);
   void __fastcall Rectangles1Click(TObject *Sender);
   void __fastcall Circles1Click(TObject *Sender);
   void __fastcall Ellipses1Click(TObject *Sender);
   void __fastcall Polygons1Click(TObject *Sender);
   void __fastcall Paint1Click(TObject *Sender);
   void __fastcall Quit1Click(TObject *Sender);
private:   // User declarations
   HDC hdc;
   HPALETTE hpal;
   int cxClient, cyClient;
   int hvb;
   const int WIDTH, HEIGHT;
   void blit(void);
public:      // User declarations
   __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif

