VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   Caption         =   "Image File Demo"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6690
   Height          =   4830
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin MSComDlg.CommonDialog CommonDialog1
      Left            =   600
      Top             =   480
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Menu mnuBmp
      Caption         =   "&BMP"
      Begin VB.Menu mnuBmpItem
         Caption         =   "&Open"
         Index           =   0
      End
      Begin VB.Menu mnuBmpItem
         Caption         =   "&Make"
         Enabled         =   0   'False
         Index           =   1
      End
      Begin VB.Menu mnuBmpItem
         Caption         =   "&Info"
         Enabled         =   0   'False
         Index           =   2
      End
   End
   Begin VB.Menu mnuPcx
      Caption         =   "&PCX"
      Begin VB.Menu mnuPcxItem
         Caption         =   "&Open"
         Index           =   0
      End
      Begin VB.Menu mnuPcxItem
         Caption         =   "&Make"
         Enabled         =   0   'False
         Index           =   1
      End
      Begin VB.Menu mnuPcxItem
         Caption         =   "&Info"
         Enabled         =   0   'False
         Index           =   2
      End
   End
   Begin VB.Menu mnuFliFlc
      Caption         =   "&FLI/FLC"
      Begin VB.Menu mnuFliFlcItem
         Caption         =   "&Open"
         Index           =   0
      End
      Begin VB.Menu mnuFliFlcItem
         Caption         =   "&Play"
         Enabled         =   0   'False
         Index           =   1
      End
      Begin VB.Menu mnuFliFlcItem
         Caption         =   "&Frame"
         Enabled         =   0   'False
         Index           =   2
      End
      Begin VB.Menu mnuFliFlcItem
         Caption         =   "&Reset"
         Enabled         =   0   'False
         Index           =   3
      End
      Begin VB.Menu mnuFliFlcItem
         Caption         =   "&Info"
         Enabled         =   0   'False
         Index           =   4
      End
   End
   Begin VB.Menu mnuJpeg
      Caption         =   "&JPEG"
      Begin VB.Menu mnuJpegItem
         Caption         =   "&Open"
         Index           =   0
      End
      Begin VB.Menu mnuJpegItem
         Caption         =   "&Info"
         Enabled         =   0   'False
         Index           =   1
      End
   End
   Begin VB.Menu mnuQuit
      Caption         =   "&Quit"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  IMAGE.FRM                                                                 *
'                                                                            *
'  This program demonstrates the Fastgraph for Windows image file display    *
'  and creation functions.                                                   *
'                                                                            *
'*****************************************************************************

Dim Context(16) As Byte
Dim FileHeader(128) As Byte
Dim FilePalette(768) As Byte
Dim FileName As String
Dim OpenFile As String
Dim MBtext As String

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long
Dim cxBuffer As Long, cyBuffer As Long

Dim Colors As Long
Dim Frames As Integer

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb = fg_vballoc(4, 4)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Call fg_setcolor(25)
   Call fg_fillpage
End Sub

Private Sub Form_Paint()
   Call fg_vbscale(0, fg_getmaxx(), 0, fg_getmaxy(), 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub

'*****************************************************************************
'                                                                            *
'  Event handlers for the items on the BMP menu.                             *
'                                                                            *
'*****************************************************************************

Private Sub mnuBmpItem_Click(Index As Integer)
   Dim ColorDepth As Long
   On Error GoTo ErrHandler

   Select Case Index
      Case 0   ' Open
         CommonDialog1.CancelError = True
         CommonDialog1.DefaultExt = "bmp"
         CommonDialog1.FileName = ""
         CommonDialog1.Filter = "BMP files (*.BMP)|*.BMP"
         CommonDialog1.Flags = cdlOFNReadOnly
         CommonDialog1.ShowOpen
         FileName = CommonDialog1.FileName
         If fg_bmphead(FileName, FileHeader(0)) < 0 Then
            Call MsgBox(FileName + " is not a BMP file.", vbCritical, "Error")
            Exit Sub
         End If
         Screen.MousePointer = 11
         Colors = fg_bmppal(FileName, FilePalette(0))
         Call fg_bmpsize(FileHeader(0), cxBuffer, cyBuffer)
         Call SwitchBuffers
         Call fg_showbmp(FileName, 0)
         Call fg_vbscale(0, cxBuffer - 1, 0, cyBuffer - 1, 0, cxClient - 1, 0, cyClient - 1)
         Screen.MousePointer = 0
         OpenFile = FileName

         mnuBmpItem(1).Enabled = True
         mnuBmpItem(2).Enabled = True
         mnuPcxItem(1).Enabled = True
         mnuPcxItem(2).Enabled = False
         mnuFliFlcItem(1).Enabled = False
         mnuFliFlcItem(2).Enabled = False
         mnuFliFlcItem(3).Enabled = False
         mnuFliFlcItem(4).Enabled = False
         mnuJpegItem(1).Enabled = False

      Case 1   ' Make
         CommonDialog1.CancelError = True
         CommonDialog1.DefaultExt = "bmp"
         CommonDialog1.FileName = Left(FileName, InStr(FileName, ".") - 1)
         CommonDialog1.Filter = "BMP files (*.BMP)|*.BMP"
         CommonDialog1.Flags = cdlOFNHideReadOnly + cdlOFNOverwritePrompt + _
                               cdlOFNPathMustExist
         CommonDialog1.ShowSave
         FileName = CommonDialog1.FileName
         If Colors = 0 Then
           ColorDepth = 24
         ElseIf Colors = 256 Then
           ColorDepth = 8
         ElseIf Colors = 16 Then
           ColorDepth = 4
         Else
           ColorDepth = 1
         End If
         Screen.MousePointer = 11
         Call fg_makebmp(0, cxBuffer - 1, 0, cyBuffer - 1, ColorDepth, FileName)
         Screen.MousePointer = 0

      Case 2   ' Info
         MBtext = OpenFile + vbCr + _
                  Str(cxBuffer) + " x" + Str(cyBuffer) + " pixels" + vbCr
         If Colors > 0 Then
            MBtext = MBtext + Str(Colors) + " colors"
         Else
            MBtext = MBtext + "24-bit RGB"
         End If
         Call MsgBox(MBtext, vbInformation, "Information")
   End Select
   Exit Sub

ErrHandler:  ' user pressed Cancel button
   Exit Sub
End Sub

'*****************************************************************************
'                                                                            *
'  Event handlers for the items on the PCX menu.                             *
'                                                                            *
'*****************************************************************************

Private Sub mnuPcxItem_Click(Index As Integer)
   On Error GoTo ErrHandler

   Select Case Index
      Case 0   ' Open
         CommonDialog1.CancelError = True
         CommonDialog1.DefaultExt = "pcx"
         CommonDialog1.FileName = ""
         CommonDialog1.Filter = "PCX files (*.PCX)|*.PCX"
         CommonDialog1.Flags = cdlOFNReadOnly
         CommonDialog1.ShowOpen
         FileName = CommonDialog1.FileName
         If fg_pcxhead(FileName, FileHeader(0)) < 0 Then
            Call MsgBox(FileName + " is not a PCX file.", vbCritical, "Error")
            Exit Sub
         End If
         Screen.MousePointer = 11
         Colors = fg_pcxpal(FileName, FilePalette(0))
         Call fg_pcxsize(FileHeader(0), cxBuffer, cyBuffer)
         Call SwitchBuffers
         Call fg_move(0, 0)
         Call fg_showpcx(FileName, 2)
         Call fg_vbscale(0, cxBuffer - 1, 0, cyBuffer - 1, 0, cxClient - 1, 0, cyClient - 1)
         Screen.MousePointer = 0
         OpenFile = FileName

         mnuPcxItem(1).Enabled = True
         mnuPcxItem(2).Enabled = True
         mnuBmpItem(1).Enabled = True
         mnuBmpItem(2).Enabled = False
         mnuFliFlcItem(1).Enabled = False
         mnuFliFlcItem(2).Enabled = False
         mnuFliFlcItem(3).Enabled = False
         mnuFliFlcItem(4).Enabled = False
         mnuJpegItem(1).Enabled = False

      Case 1   ' Make
         CommonDialog1.CancelError = True
         CommonDialog1.DefaultExt = "pcx"
         CommonDialog1.FileName = Left(FileName, InStr(FileName, ".") - 1)
         CommonDialog1.Filter = "PCX files (*.PCX)|*.PCX"
         CommonDialog1.Flags = cdlOFNHideReadOnly + cdlOFNOverwritePrompt + _
                               cdlOFNPathMustExist
         CommonDialog1.ShowSave
         FileName = CommonDialog1.FileName
         Screen.MousePointer = 11
         Call fg_makepcx(0, cxBuffer - 1, 0, cyBuffer - 1, FileName)
         Screen.MousePointer = 0

      Case 2   ' Info
         MBtext = OpenFile + vbCr + _
                  Str(cxBuffer) + " x" + Str(cyBuffer) + " pixels" + vbCr
         If Colors > 0 Then
            MBtext = MBtext + Str(Colors) + " colors"
         Else
            MBtext = MBtext + "24-bit RGB"
         End If
         Call MsgBox(MBtext, vbInformation, "Information")
   End Select
   Exit Sub

ErrHandler:  ' user pressed Cancel button
   Exit Sub
End Sub

'*****************************************************************************
'                                                                            *
'  Event handlers for the items on the FLI/FLC menu.                         *
'                                                                            *
'*****************************************************************************

Private Sub mnuFliFlcItem_Click(Index As Integer)
   On Error GoTo ErrHandler

   Select Case Index
      Case 0   ' Open
         CommonDialog1.CancelError = True
         CommonDialog1.DefaultExt = "fli"
         CommonDialog1.FileName = ""
         CommonDialog1.Filter = "flic files (*.FLI,*.FLC)|*.FLI;*.FLC"
         CommonDialog1.Flags = cdlOFNReadOnly
         CommonDialog1.ShowOpen
         FileName = CommonDialog1.FileName
         If fg_flichead(FileName, FileHeader(0)) < 0 Then
            Call MsgBox(FileName + " is not an FLI or FLC file.", vbCritical, "Error")
            Exit Sub
         End If
         Colors = 256
         Call fg_flicsize(FileHeader(0), cxBuffer, cyBuffer)
         Call SwitchBuffers
         Call fg_flicopen(FileName, Context(0))
         Call fg_flicplay(Context(0), 1, 0)
         Call fg_vbscale(0, cxBuffer - 1, 0, cyBuffer - 1, 0, cxClient - 1, 0, cyClient - 1)
         Frames = FileHeader(7) * 256 + FileHeader(6)
         OpenFile = FileName

         mnuFliFlcItem(1).Enabled = True
         mnuFliFlcItem(2).Enabled = True
         mnuFliFlcItem(3).Enabled = True
         mnuFliFlcItem(4).Enabled = True
         mnuBmpItem(1).Enabled = True
         mnuBmpItem(2).Enabled = False
         mnuPcxItem(1).Enabled = True
         mnuPcxItem(2).Enabled = False
         mnuJpegItem(1).Enabled = False

      Case 1   ' Play
         Screen.MousePointer = 11
         Call fg_showflic(FileName, 0, 1)
         Screen.MousePointer = 0
         Call fg_flicskip(Context(0), -1)

      Case 2   ' Frame
         If fg_flicplay(Context(0), 1, 0) = 0 Then
            Call fg_flicskip(Context(0), -1)
            Call fg_flicplay(Context(0), 1, 0)
         End If
         Call fg_vbscale(0, cxBuffer - 1, 0, cyBuffer - 1, 0, cxClient - 1, 0, cyClient - 1)

      Case 3   ' Reset
         Call fg_flicskip(Context(0), -1)
         Call fg_flicplay(Context(0), 1, 0)
         Call fg_vbscale(0, cxBuffer - 1, 0, cyBuffer - 1, 0, cxClient - 1, 0, cyClient - 1)

      Case 4   ' Info
         MBtext = OpenFile + vbCr + _
                  Str(cxBuffer) + " x" + Str(cyBuffer) + " pixels" + vbCr + _
                  Str(Frames) + " frames"
         Call MsgBox(MBtext, vbInformation, "Information")
   End Select
   Exit Sub

ErrHandler:  ' user pressed Cancel button
   Exit Sub
End Sub

'*****************************************************************************
'                                                                            *
'  Event handlers for the items on the JPEG menu.                            *
'                                                                            *
'*****************************************************************************

Private Sub mnuJpegItem_Click(Index As Integer)
   Dim Buffer() As Byte
   Dim BuffSize As Long
   On Error GoTo ErrHandler

   Select Case Index
      Case 0   ' Open
         CommonDialog1.CancelError = True
         CommonDialog1.DefaultExt = "jpg"
         CommonDialog1.FileName = ""
         CommonDialog1.Filter = "JPEG files (*.JPG)|*.JPG"
         CommonDialog1.Flags = cdlOFNReadOnly
         CommonDialog1.ShowOpen
         FileName = CommonDialog1.FileName
         If fg_jpeghead(FileName, FileHeader(0)) < 0 Then
            Call MsgBox(FileName + " is not a JPEG file.", vbCritical, "Error")
            Exit Sub
         End If
         Screen.MousePointer = 11
         Colors = 0
         BuffSize = fg_jpegmem(FileHeader(0))
         ReDim Buffer(BuffSize)
         Call fg_jpegbuf(Buffer(0), BuffSize)
         Call fg_jpegsize(FileHeader(0), cxBuffer, cyBuffer)
         Call SwitchBuffers
         Call fg_move(0, 0)
         Call fg_showjpeg(FileName, 0)
         Erase Buffer
         Call fg_vbscale(0, cxBuffer - 1, 0, cyBuffer - 1, 0, cxClient - 1, 0, cyClient - 1)
         Screen.MousePointer = 0
         OpenFile = FileName

         mnuPcxItem(1).Enabled = True
         mnuPcxItem(2).Enabled = False
         mnuBmpItem(1).Enabled = True
         mnuBmpItem(2).Enabled = False
         mnuFliFlcItem(1).Enabled = False
         mnuFliFlcItem(2).Enabled = False
         mnuFliFlcItem(3).Enabled = False
         mnuFliFlcItem(4).Enabled = False
         mnuJpegItem(1).Enabled = True

      Case 1   ' Info
         MBtext = OpenFile + vbCr + _
                  Str(cxBuffer) + " x" + Str(cyBuffer) + " pixels" + vbCr + _
                  "24-bit RGB"
         Call MsgBox(MBtext, vbInformation, "Information")
   End Select
   Exit Sub

ErrHandler:  ' user pressed Cancel button
   Exit Sub
End Sub

Private Sub mnuQuit_Click()
   Unload Me
End Sub

'*****************************************************************************
'                                                                            *
'  SwitchBuffers                                                             *
'                                                                            *
'  Close the and release the active virtual buffer, then create and open a   *
'  new virtual buffer to hold the new image file.                            *
'                                                                            *
'*****************************************************************************

Private Sub SwitchBuffers()
   Call fg_vbclose
   Call fg_vbfree(hvb)
   If Colors = 0 Then
      Call fg_vbdepth(24)
   Else
      Call fg_vbdepth(8)
   End If
   hvb = fg_vballoc(cxBuffer, cyBuffer)
   Call fg_vbopen(hvb)
   Call fg_vbcolors
End Sub
