//---------------------------------------------------------------------------
#ifndef ImageUH
#define ImageUH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Dialogs.hpp>
#include <string.h>
#include <fgwin.h>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu1;
	TMenuItem *BMP1;
	TMenuItem *OpenBMP;
	TMenuItem *MakeBMP;
	TMenuItem *InfoBMP;
	TMenuItem *PCX1;
	TMenuItem *OpenPCX;
	TMenuItem *MakePCX;
	TMenuItem *InfoPCX;
	TMenuItem *FLIFLC1;
	TMenuItem *OpenFLIC;
	TMenuItem *PlayFLIC;
	TMenuItem *FrameFLIC;
	TMenuItem *ResetFLIC;
	TMenuItem *InfoFLIC;
	TMenuItem *JPEG1;
	TMenuItem *OpenJPEG;
	TMenuItem *InfoJPEG;
	TMenuItem *Quit;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall OpenBMPClick(TObject *Sender);
	void __fastcall MakeBMPClick(TObject *Sender);
	void __fastcall InfoBMPClick(TObject *Sender);
	void __fastcall OpenPCXClick(TObject *Sender);
	void __fastcall MakePCXClick(TObject *Sender);
	void __fastcall InfoPCXClick(TObject *Sender);
	void __fastcall OpenFLICClick(TObject *Sender);
	void __fastcall PlayFLICClick(TObject *Sender);
	void __fastcall FrameFLICClick(TObject *Sender);
	void __fastcall ResetFLICClick(TObject *Sender);
	void __fastcall InfoFLICClick(TObject *Sender);
	void __fastcall OpenJPEGClick(TObject *Sender);
	void __fastcall InfoJPEGClick(TObject *Sender);
	void __fastcall QuitClick(TObject *Sender);
private:	// User declarations
   HDC hdc;
   HPALETTE hpal;
   int hvb;
   UINT cxClient, cyClient;
   int cxBuffer, cyBuffer;
   int colors;
   String MBText;
   char mb_text[256];
   char file_header[128];
   char file_name[256];
   char file_palette[768];
   char context[16];
   int frames;
   void __fastcall switch_buffers(void);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
