VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   Caption         =   "Gouraud Shading Demo"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6690
   Height          =   4545
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  SHADE.FRM                                                                 *
'                                                                            *
'  This program demonstrates Gouraud shading in a high color virtual buffer. *
'                                                                            *
'*****************************************************************************

Const vbWidth = 640
Const vbHeight = 480
Const vbDepth = 16

Dim hPal As Long
Dim hvb As Long
Dim cxClient As Long, cyClient As Long

Option Base 1
Dim Vertex(8) As Long
Dim RGB(12) As Byte

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   Call fg_vbdepth(vbDepth)
   hvb = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb)
   Call fg_vbcolors

   Vertex(1) = 60: Vertex(2) = 0
   Vertex(3) = 199: Vertex(4) = 60
   Vertex(5) = 160: Vertex(6) = 175
   Vertex(7) = 0: Vertex(8) = 199

   RGB(1) = 255: RGB(2) = 255: RGB(3) = 255
   RGB(4) = 0: RGB(5) = 255: RGB(6) = 0
   RGB(7) = 255: RGB(8) = 0: RGB(9) = 0
   RGB(10) = 0: RGB(11) = 0: RGB(12) = 255

   Call fg_setcolor(-1)
   Call fg_fillpage
   Call fg_polyoff(220, 140)
   Call fg_gouraud(Vertex(1), RGB(1), 4)
End Sub

Private Sub Form_Paint()
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb)
   Call fg_vbfin
End Sub
