/****************************************************************************\
*                                                                            *
*  STRING1.CPP                                                               *
*  STRING1U.CPP                                                              *
*                                                                            *
*  This program shows how to display strings in the client area.             *
*                                                                            *
\****************************************************************************/

#include <vcl\vcl.h>
#pragma hdrstop

#include "String1U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner),
      WIDTH(320),
      HEIGHT(240)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
   fg_realize(hpal);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hdc = GetDC(Form1->Handle);
   fg_setdc(hdc);
   hpal = fg_defpal();
   fg_realize(hpal);

   fg_vbinit();
   hvb = fg_vballoc(WIDTH,HEIGHT);
   fg_vbopen(hvb);
   fg_vbcolors();

   fg_setcolor(24);
   fg_fillpage();

   Application->OnActivate = OnActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
   fg_vbscale(0,fg_getmaxx(),0,fg_getmaxy(),0,cxClient-1,0,cyClient-1);
   fg_setcolor(19);

   // upper vertical justification
   fg_move(fg_xclient(0),fg_yclient(0));
   fg_justify(-1,1);
   fg_print("FG/Windows",10);
   fg_move(fg_xclient(WIDTH/2),fg_yclient(0));
   fg_justify(0,1);
   fg_print("FG/Windows",10);
   fg_move(fg_xclient(WIDTH-1),fg_yclient(0));
   fg_justify(1,1);
   fg_print("FG/Windows",10);

   // centered vertical justification
   fg_move(fg_xclient(0),fg_yclient(HEIGHT/2));
   fg_justify(-1,0);
   fg_print("FG/Windows",10);
   fg_move(fg_xclient(WIDTH/2),fg_yclient(HEIGHT/2));
   fg_justify(0,0);
   fg_print("FG/Windows",10);
   fg_move(fg_xclient(WIDTH-1),fg_yclient(HEIGHT/2));
   fg_justify(1,0);
   fg_print("FG/Windows",10);

   // lower vertical justification
   fg_move(fg_xclient(0),fg_yclient(HEIGHT-1));
   fg_justify(-1,-1);
   fg_print("FG/Windows",10);
   fg_move(fg_xclient(WIDTH/2),fg_yclient(HEIGHT-1));
   fg_justify(0,-1);
   fg_print("FG/Windows",10);
   fg_move(fg_xclient(WIDTH-1),fg_yclient(HEIGHT-1));
   fg_justify(1,-1);
   fg_print("FG/Windows",10);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
   cxClient = ClientWidth;
   cyClient = ClientHeight;
   Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   fg_vbclose();
   fg_vbfree(hvb);
   fg_vbfin();
   DeleteObject(hpal);
   ReleaseDC(Form1->Handle,hdc);
}
//---------------------------------------------------------------------------
