{*****************************************************************************
*                                                                            *
*  CUBE2.DPR                                                                 *
*  CUBE2U.PAS                                                                *
*                                                                            *
*  This program uses Fastgraph's 3D geometry system to draw a cube. Each     *
*  of the six cube faces is a different solid color. Uses the approach of    *
*  projecting the entire cube in one operation to take advantage of shared   *
*  vertices between faces.                                                   *
*                                                                            *
*****************************************************************************}

program Cube2;

uses
  Forms,
  Cube2U in 'CUBE2U.PAS' {Form1};

{$R *.RES}

begin
  Application.CreateForm(TForm1, Form1);
  Application.Run;
end.
