VERSION 4.00
Begin VB.Form Form1
   BackColor       =   &H00FFFFFF&
   Caption         =   "Virtual Buffer Copy Demo"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6690
   Height          =   4830
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.Menu mnuCut
      Caption         =   "&Cut"
   End
   Begin VB.Menu mnuPaste
      Caption         =   "&Paste"
      Enabled         =   0   'False
   End
   Begin VB.Menu mnuQuit
      Caption         =   "&Quit"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

'*****************************************************************************
'                                                                            *
'  VBDEMO.FRM                                                                *
'                                                                            *
'  This program demonstrates how to copy the contents of one virtual buffer  *
'  to another, with and without transparent colors.                          *
'                                                                            *
'*****************************************************************************

Const vbWidth = 640
Const vbHeight = 480

Dim hPal As Long
Dim hvb1 As Long, hvb2 As Long
Dim cxClient As Long, cyClient As Long

Private Sub Form_Activate()
   Call fg_realize(hPal)
   Refresh
End Sub

Private Sub Form_Load()
   ScaleMode = 3
   Call fg_setdc(hDC)
   hPal = fg_defpal()
   Call fg_realize(hPal)

   Call fg_vbinit
   hvb2 = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb2)
   Call fg_vbcolors
   hvb1 = fg_vballoc(vbWidth, vbHeight)
   Call fg_vbopen(hvb1)
   Call fg_vbcolors

   Call fg_setcolor(25)
   Call fg_fillpage
   Call fg_setcolor(20)
   Call fg_rect(vbWidth / 4, vbWidth * 3 / 4, vbHeight / 4, vbHeight * 3 / 4)
End Sub

Private Sub Form_Paint()
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub Form_Resize()
   cxClient = ScaleWidth
   cyClient = ScaleHeight
   Refresh
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call fg_vbclose
   Call fg_vbfree(hvb1)
   Call fg_vbfree(hvb2)
   Call fg_vbfin
End Sub

Private Sub mnuCut_Click()
   Call fg_vbcopy(0, vbWidth - 1, 0, vbHeight - 1, 0, vbHeight - 1, hvb1, hvb2)
   Call fg_erase
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
   mnuPaste.Enabled = True
End Sub

Private Sub mnuPaste_Click()
   Call fg_tcdefine(25, 1)
   Call fg_vbtccopy(0, vbWidth - 1, 0, vbHeight - 1, 0, vbHeight - 1, hvb2, hvb1)
   Call fg_vbscale(0, vbWidth - 1, 0, vbHeight - 1, 0, cxClient - 1, 0, cyClient - 1)
End Sub

Private Sub mnuQuit_Click()
   Unload Me
End Sub
